import Vue from 'vue'
import VueRouter from 'vue-router'
import VueHead from 'vue-head'
let path = require('path')
import {tools,lifecycle} from 'wevue-tools'
import {globalVueInit} from 'wevue-tools/global-vue-init'

import * as vueConfig from 'vueroot/vue.conf.js'
let beforeVueInit = vueConfig.before||(new Function())
let afterVueInit = vueConfig.after || (new Function())

let projectRouterMode = tools.advanceAppConfig().mode

/**
 * @lzq 
 * 如果引入了微信sdk则覆盖wevue的wx入口
 * 建议以后不要使用wevue wx api
 * 使用shoots
 */
if (window.wx) {
    wx = window.wx;
}
/**
 * 产品环境关闭dev工具
 */
Vue.config.devtools = process.env.NODE_ENV==='production' ? false :true

Vue.use(VueHead,{
    separator: '',
    complement: ''
})
Vue.use(VueRouter)
/**
 * @lzq  添加页面 router
 */
var routes = tools.getAppRouters()
let router = new VueRouter({
    mode: projectRouterMode || 'hash',
    
    routes:routes
})
router.afterEach((to, from) => {
    // to and from are both route objects
    lifecycle.afterRouteChange(to,from)
})

let AppView = require('../@layout/App.vue')


globalVueInit(Vue)
/**
 * @lzq
 * 给Vue new之前做最后的补充
 */
let initOptions = {
    router,
    render: h => h(AppView.default?AppView.default:AppView)
}
beforeVueInit(Vue,initOptions)
new Vue(initOptions).$mount("#__wevue_app")

/**
 * @lzq
 * 给Vue new之后做最后的补充
 */
afterVueInit(Vue,initOptions)